/*
 * Klient.java
 *
 * Created on 22. nor 2005, 20:45
 */

package cz.vse.xkucf03.chat.klient;

import cz.vse.xkucf03.chat.KlientRozhrani;
import cz.vse.xkucf03.chat.ServerRozhrani;
import cz.vse.xkucf03.chat.Zprava;
import java.rmi.Naming;

/**
 *
 * @author fiki
 */
public class Klient extends java.rmi.server.UnicastRemoteObject implements KlientRozhrani {
    
    /**
     * Holds value of property klic.
     */
    private int klic = 0;
    
    /**
     * Holds value of property server.
     */
    private String serverAdresa;
    
    /**
     * Holds value of property login.
     */
    private String login;
    
    /**
     * Holds value of property heslo.
     */
    private String heslo;
    
    /** Creates a new instance of Klient */
    public Klient(String serverAdresa, String login, String heslo, KlientUI ui) throws java.rmi.RemoteException {
        this.serverAdresa = serverAdresa;
        this.login = login;
        this.heslo = heslo;
        this.ui = ui;
    }
    
    public void prijmiZpravu(int klic, Zprava z) {
        ui.zobrazZpravu(z);
        
    }
    
    public void prijmiHistoriiZprav(int klic, Zprava[] historie) {
        ui.prijmiHistoriiZprav(historie);
        
    }
    
    /**
     * Getter for property klic.
     * @return Value of property klic.
     */
    public int getKlic() {
        if (klic == 0) {
            klic = new java.util.Random().nextInt();
        } 
        return this.klic;
        
    }
    
    /**
     * Setter for property klic.
     * @param klic New value of property klic.
     */
    public void setKlic(int klic) {
        
        this.klic = klic;
    }
    
    /**
     * Getter for property server.
     * @return Value of property server.
     */
    public String getServer() {
        
        return this.serverAdresa;
    }
    
    /**
     * Setter for property server.
     * @param server New value of property server.
     */
    public void setServer(String server) {
        
        this.serverAdresa = server;
    }
    
    /**
     * Getter for property login.
     * @return Value of property login.
     */
    public String getLogin() {
        
        return this.login;
    }
    
    /**
     * Setter for property login.
     * @param login New value of property login.
     */
    public void setLogin(String login) {
        
        this.login = login;
    }
    
    /**
     * Getter for property heslo.
     * @return Value of property heslo.
     */
    private String getHeslo() {
        
        return this.heslo;
    }
    
    /**
     * Setter for property heslo.
     * @param heslo New value of property heslo.
     */
    public void setHeslo(String heslo) {
        
        this.heslo = heslo;
    }
    
    private KlientUI ui;
    
    public void pripoj() {
        try {
            System.out.println("Klient_pripoj: lookup");
            server = (ServerRozhrani)java.rmi.Naming.lookup("rmi://" + serverAdresa + ":1099/ChatServer");
            
            System.out.println("Klient_pripoj: rebind this");
            Naming.rebind("rmi://localhost:1099/Klient_" + login, this);
            
            System.out.println("Klient_pripoj: prihlasKlienta: " + login + heslo + getKlic());
            token = server.prihlasKlienta(login, heslo, getKlic());
            
            
        } catch (Exception e) {
            System.out.println("Klient_pripoj: " + e);
            
        }
    }
    
    private ServerRozhrani server;
    
    /**
     * Holds value of property token.
     */
    private String token;
    
    public void posliZpravu(Zprava z) {
        try {
            System.out.println("Zprva: " + z.toString());
            System.out.println("Token: " + token.toString());
            System.out.println("Server: " + server.toString());
            
            server.posliZpravu(token, z);
        } catch (Exception e) {
            System.out.println("Klient_posliZpravu: " + e);
            
        }
    }
    
    /**
     * Getter for property token.
     * @return Value of property token.
     */
    public String getToken() {
        
        return this.token;
    }
    
    /**
     * Setter for property token.
     * @param token New value of property token.
     */
    public void setToken(String token) {
        
        this.token = token;
    }
    
}
